aboutsummaryrefslogtreecommitdiffstats
path: root/package/base-files/default/sbin
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2005-10-22 19:54:33 +0000
committerFelix Fietkau <nbd@openwrt.org>2005-10-22 19:54:33 +0000
commite3c6fbd86efeb4821179629f4ca3d0c17902b759 (patch)
tree428493a8d33eaf1238b4c5fe29835b3ccacac976 /package/base-files/default/sbin
parent92b1e31d3db53979cce9779368b1042a34d69c1f (diff)
downloadmaster-187ad058-e3c6fbd86efeb4821179629f4ca3d0c17902b759.tar.gz
master-187ad058-e3c6fbd86efeb4821179629f4ca3d0c17902b759.tar.bz2
master-187ad058-e3c6fbd86efeb4821179629f4ca3d0c17902b759.zip
add base-files change from whiterussian
git-svn-id: svn://svn.openwrt.org/openwrt/trunk/openwrt@2257 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/base-files/default/sbin')
-rwxr-xr-xpackage/base-files/default/sbin/mount_root13
1 files changed, 11 insertions, 2 deletions
diff --git a/package/base-files/default/sbin/mount_root b/package/base-files/default/sbin/mount_root
index bc8d69c79b..c8edaaa2fa 100755
--- a/package/base-files/default/sbin/mount_root
+++ b/package/base-files/default/sbin/mount_root
@@ -1,10 +1,15 @@
#!/bin/sh
. /etc/nvram.sh
+is_clean() {
+ OFFSET="$((0x$(dd if=/dev/mtdblock/1 bs=1 skip=$((0x14)) count=2 2>&- | hexdump | grep 0000000 | cut -d ' ' -f 2) - 1))"
+ dd if=/dev/mtdblock/1 bs=1 skip=$OFFSET count=1 2>&- | hexdump -v | grep ' 0000' > /dev/null && return 255 || return 0
+}
+
if [ "$1" != "failsafe" ]; then
mount | grep jffs2 >&-
if [ $? = 0 ] ; then
if [ $(cat /proc/mtd | wc -l) = 6 ]; then
- [ -f /proc/sys/diag ] && echo 5 > /proc/sys/diag
+ echo 5 > /proc/sys/diag
mtd unlock linux
mtd erase OpenWrt
jffs2root --move
@@ -13,7 +18,11 @@ if [ "$1" != "failsafe" ]; then
mount -o remount,rw /dev/root /
fi
else
- if [ \! -x /usr/sbin/nvram -o -z "$(nvram get no_root_swap)" ]; then
+ if [ -z "$(nvram get no_root_swap)" ]; then
+ is_clean || {
+ mtd erase OpenWrt
+ jffs2root --clean
+ }
mtd unlock OpenWrt
mount -t jffs2 /dev/mtdblock/4 /jffs
pivot_root /jffs /jffs/rom